/* puzzle.c generated by valac 0.46.6, the Vala compiler
 * generated from puzzle.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * Copyright (C) 2010-2013 Robert Ancell
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 2 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */

#include <glib-object.h>
#include <glib.h>
#include <float.h>
#include <math.h>

#define TYPE_TILE (tile_get_type ())
#define TILE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TILE, Tile))
#define TILE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TILE, TileClass))
#define IS_TILE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TILE))
#define IS_TILE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TILE))
#define TILE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TILE, TileClass))

typedef struct _Tile Tile;
typedef struct _TileClass TileClass;
typedef struct _TilePrivate TilePrivate;
enum  {
	TILE_0_PROPERTY,
	TILE_NUM_PROPERTIES
};
static GParamSpec* tile_properties[TILE_NUM_PROPERTIES];

#define TYPE_PUZZLE (puzzle_get_type ())
#define PUZZLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PUZZLE, Puzzle))
#define PUZZLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PUZZLE, PuzzleClass))
#define IS_PUZZLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PUZZLE))
#define IS_PUZZLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PUZZLE))
#define PUZZLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PUZZLE, PuzzleClass))

typedef struct _Puzzle Puzzle;
typedef struct _PuzzleClass PuzzleClass;
typedef struct _PuzzlePrivate PuzzlePrivate;
enum  {
	PUZZLE_0_PROPERTY,
	PUZZLE_SIZE_PROPERTY,
	PUZZLE_ELAPSED_PROPERTY,
	PUZZLE_PAUSED_PROPERTY,
	PUZZLE_IS_SOLVED_PROPERTY,
	PUZZLE_CAN_MOVE_UP_PROPERTY,
	PUZZLE_CAN_MOVE_DOWN_PROPERTY,
	PUZZLE_CAN_MOVE_LEFT_PROPERTY,
	PUZZLE_CAN_MOVE_RIGHT_PROPERTY,
	PUZZLE_NUM_PROPERTIES
};
static GParamSpec* puzzle_properties[PUZZLE_NUM_PROPERTIES];
#define _g_timer_destroy0(var) ((var == NULL) ? NULL : (var = (g_timer_destroy (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	PUZZLE_TILE_MOVED_SIGNAL,
	PUZZLE_SOLVED_SIGNAL,
	PUZZLE_PAUSED_CHANGED_SIGNAL,
	PUZZLE_TICK_SIGNAL,
	PUZZLE_NUM_SIGNALS
};
static guint puzzle_signals[PUZZLE_NUM_SIGNALS] = {0};

struct _Tile {
	GObject parent_instance;
	TilePrivate * priv;
	gint north;
	gint west;
	gint east;
	gint south;
	guint x;
	guint y;
};

struct _TileClass {
	GObjectClass parent_class;
};

struct _Puzzle {
	GObject parent_instance;
	PuzzlePrivate * priv;
};

struct _PuzzleClass {
	GObjectClass parent_class;
};

struct _PuzzlePrivate {
	guint _size;
	Tile** board;
	gint board_length1;
	gint board_length2;
	gdouble clock_elapsed;
	GTimer* clock;
	guint clock_timeout;
	gboolean _paused;
};

static gpointer tile_parent_class = NULL;
static gint Puzzle_private_offset;
static gpointer puzzle_parent_class = NULL;

GType tile_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Tile, g_object_unref)
Tile* tile_new (guint x,
                guint y);
Tile* tile_construct (GType object_type,
                      guint x,
                      guint y);
static void tile_finalize (GObject * obj);
GType puzzle_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Puzzle, g_object_unref)
Puzzle* puzzle_new (guint size);
Puzzle* puzzle_construct (GType object_type,
                          guint size);
static void puzzle_start_clock (Puzzle* self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
Tile* puzzle_get_tile (Puzzle* self,
                       guint x,
                       guint y);
void puzzle_get_tile_location (Puzzle* self,
                               Tile* tile,
                               guint* x,
                               guint* y);
guint puzzle_get_size (Puzzle* self);
gboolean puzzle_tile_fits (Puzzle* self,
                           guint x0,
                           guint y0,
                           guint x1,
                           guint y1);
gboolean puzzle_can_switch (Puzzle* self,
                            guint x0,
                            guint y0,
                            guint x1,
                            guint y1);
void puzzle_switch_tiles (Puzzle* self,
                          guint x0,
                          guint y0,
                          guint x1,
                          guint y1);
gboolean puzzle_get_is_solved (Puzzle* self);
static void puzzle_stop_clock (Puzzle* self);
void puzzle_move_up (Puzzle* self);
gboolean puzzle_get_can_move_up (Puzzle* self);
void puzzle_move_down (Puzzle* self);
gboolean puzzle_get_can_move_down (Puzzle* self);
void puzzle_move_left (Puzzle* self);
gboolean puzzle_get_can_move_left (Puzzle* self);
void puzzle_move_right (Puzzle* self);
gboolean puzzle_get_can_move_right (Puzzle* self);
void puzzle_solve (Puzzle* self);
static gboolean puzzle_timeout_cb (Puzzle* self);
static void puzzle_continue_clock (Puzzle* self);
static gboolean _puzzle_timeout_cb_gsource_func (gpointer self);
gdouble puzzle_get_elapsed (Puzzle* self);
gboolean puzzle_get_paused (Puzzle* self);
void puzzle_set_paused (Puzzle* self,
                        gboolean value);
static void g_cclosure_user_marshal_VOID__OBJECT_UINT_UINT (GClosure * closure,
                                                     GValue * return_value,
                                                     guint n_param_values,
                                                     const GValue * param_values,
                                                     gpointer invocation_hint,
                                                     gpointer marshal_data);
static void puzzle_finalize (GObject * obj);
static void _vala_puzzle_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec);
static void _vala_puzzle_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

Tile*
tile_construct (GType object_type,
                guint x,
                guint y)
{
	Tile * self = NULL;
	self = (Tile*) g_object_new (object_type, NULL);
	self->x = x;
	self->y = y;
	return self;
}

Tile*
tile_new (guint x,
          guint y)
{
	return tile_construct (TYPE_TILE, x, y);
}

static void
tile_class_init (TileClass * klass,
                 gpointer klass_data)
{
	tile_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = tile_finalize;
}

static void
tile_instance_init (Tile * self,
                    gpointer klass)
{
}

static void
tile_finalize (GObject * obj)
{
	Tile * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TILE, Tile);
	G_OBJECT_CLASS (tile_parent_class)->finalize (obj);
}

GType
tile_get_type (void)
{
	static volatile gsize tile_type_id__volatile = 0;
	if (g_once_init_enter (&tile_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (TileClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tile_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Tile), 0, (GInstanceInitFunc) tile_instance_init, NULL };
		GType tile_type_id;
		tile_type_id = g_type_register_static (G_TYPE_OBJECT, "Tile", &g_define_type_info, 0);
		g_once_init_leave (&tile_type_id__volatile, tile_type_id);
	}
	return tile_type_id__volatile;
}

static inline gpointer
puzzle_get_instance_private (Puzzle* self)
{
	return G_STRUCT_MEMBER_P (self, Puzzle_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
_g_object_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
}

Puzzle*
puzzle_construct (GType object_type,
                  guint size)
{
	Puzzle * self = NULL;
	Tile** _tmp0_;
	GList* tiles = NULL;
	self = (Puzzle*) g_object_new (object_type, NULL);
	self->priv->_size = size;
	_tmp0_ = g_new0 (Tile*, ((size * 2) * size) + 1);
	self->priv->board = (_vala_array_free (self->priv->board, self->priv->board_length1 * self->priv->board_length2, (GDestroyNotify) g_object_unref), NULL);
	self->priv->board = _tmp0_;
	self->priv->board_length1 = size * 2;
	self->priv->board_length2 = size;
	{
		gint x = 0;
		x = 0;
		{
			gboolean _tmp1_ = FALSE;
			_tmp1_ = TRUE;
			while (TRUE) {
				if (!_tmp1_) {
					gint _tmp2_;
					_tmp2_ = x;
					x = _tmp2_ + 1;
				}
				_tmp1_ = FALSE;
				if (!(((guint) x) < size)) {
					break;
				}
				{
					gint y = 0;
					y = 0;
					{
						gboolean _tmp3_ = FALSE;
						_tmp3_ = TRUE;
						while (TRUE) {
							Tile** _tmp5_;
							gint _tmp5__length1;
							gint _tmp5__length2;
							Tile* _tmp6_;
							if (!_tmp3_) {
								gint _tmp4_;
								_tmp4_ = y;
								y = _tmp4_ + 1;
							}
							_tmp3_ = FALSE;
							if (!(((guint) y) < size)) {
								break;
							}
							_tmp5_ = self->priv->board;
							_tmp5__length1 = self->priv->board_length1;
							_tmp5__length2 = self->priv->board_length2;
							_tmp6_ = tile_new ((guint) x, (guint) y);
							_g_object_unref0 (_tmp5_[(x * _tmp5__length2) + y]);
							_tmp5_[(x * _tmp5__length2) + y] = _tmp6_;
						}
					}
				}
			}
		}
	}
	{
		gint x = 0;
		x = 0;
		{
			gboolean _tmp7_ = FALSE;
			_tmp7_ = TRUE;
			while (TRUE) {
				if (!_tmp7_) {
					gint _tmp8_;
					_tmp8_ = x;
					x = _tmp8_ + 1;
				}
				_tmp7_ = FALSE;
				if (!(((guint) x) < size)) {
					break;
				}
				{
					gint y = 0;
					y = 0;
					{
						gboolean _tmp9_ = FALSE;
						_tmp9_ = TRUE;
						while (TRUE) {
							gint32 n = 0;
							if (!_tmp9_) {
								gint _tmp10_;
								_tmp10_ = y;
								y = _tmp10_ + 1;
							}
							_tmp9_ = FALSE;
							if (!(((guint) y) <= size)) {
								break;
							}
							n = g_random_int_range ((gint32) 0, (gint32) 10);
							if ((y - 1) >= 0) {
								Tile** _tmp11_;
								gint _tmp11__length1;
								gint _tmp11__length2;
								Tile* _tmp12_;
								_tmp11_ = self->priv->board;
								_tmp11__length1 = self->priv->board_length1;
								_tmp11__length2 = self->priv->board_length2;
								_tmp12_ = _tmp11_[(x * _tmp11__length2) + (y - 1)];
								_tmp12_->south = (gint) n;
							}
							if (((guint) y) < size) {
								Tile** _tmp13_;
								gint _tmp13__length1;
								gint _tmp13__length2;
								Tile* _tmp14_;
								_tmp13_ = self->priv->board;
								_tmp13__length1 = self->priv->board_length1;
								_tmp13__length2 = self->priv->board_length2;
								_tmp14_ = _tmp13_[(x * _tmp13__length2) + y];
								_tmp14_->north = (gint) n;
							}
						}
					}
				}
			}
		}
	}
	{
		gint x = 0;
		x = 0;
		{
			gboolean _tmp15_ = FALSE;
			_tmp15_ = TRUE;
			while (TRUE) {
				if (!_tmp15_) {
					gint _tmp16_;
					_tmp16_ = x;
					x = _tmp16_ + 1;
				}
				_tmp15_ = FALSE;
				if (!(((guint) x) <= size)) {
					break;
				}
				{
					gint y = 0;
					y = 0;
					{
						gboolean _tmp17_ = FALSE;
						_tmp17_ = TRUE;
						while (TRUE) {
							gint32 n = 0;
							if (!_tmp17_) {
								gint _tmp18_;
								_tmp18_ = y;
								y = _tmp18_ + 1;
							}
							_tmp17_ = FALSE;
							if (!(((guint) y) < size)) {
								break;
							}
							n = g_random_int_range ((gint32) 0, (gint32) 10);
							if ((x - 1) >= 0) {
								Tile** _tmp19_;
								gint _tmp19__length1;
								gint _tmp19__length2;
								Tile* _tmp20_;
								_tmp19_ = self->priv->board;
								_tmp19__length1 = self->priv->board_length1;
								_tmp19__length2 = self->priv->board_length2;
								_tmp20_ = _tmp19_[((x - 1) * _tmp19__length2) + y];
								_tmp20_->east = (gint) n;
							}
							if (((guint) x) < size) {
								Tile** _tmp21_;
								gint _tmp21__length1;
								gint _tmp21__length2;
								Tile* _tmp22_;
								_tmp21_ = self->priv->board;
								_tmp21__length1 = self->priv->board_length1;
								_tmp21__length2 = self->priv->board_length2;
								_tmp22_ = _tmp21_[(x * _tmp21__length2) + y];
								_tmp22_->west = (gint) n;
							}
						}
					}
				}
			}
		}
	}
	tiles = NULL;
	{
		gint x = 0;
		x = 0;
		{
			gboolean _tmp23_ = FALSE;
			_tmp23_ = TRUE;
			while (TRUE) {
				if (!_tmp23_) {
					gint _tmp24_;
					_tmp24_ = x;
					x = _tmp24_ + 1;
				}
				_tmp23_ = FALSE;
				if (!(((guint) x) < size)) {
					break;
				}
				{
					gint y = 0;
					y = 0;
					{
						gboolean _tmp25_ = FALSE;
						_tmp25_ = TRUE;
						while (TRUE) {
							Tile** _tmp27_;
							gint _tmp27__length1;
							gint _tmp27__length2;
							Tile* _tmp28_;
							Tile* _tmp29_;
							Tile** _tmp30_;
							gint _tmp30__length1;
							gint _tmp30__length2;
							if (!_tmp25_) {
								gint _tmp26_;
								_tmp26_ = y;
								y = _tmp26_ + 1;
							}
							_tmp25_ = FALSE;
							if (!(((guint) y) < size)) {
								break;
							}
							_tmp27_ = self->priv->board;
							_tmp27__length1 = self->priv->board_length1;
							_tmp27__length2 = self->priv->board_length2;
							_tmp28_ = _tmp27_[(x * _tmp27__length2) + y];
							_tmp29_ = _g_object_ref0 (_tmp28_);
							tiles = g_list_append (tiles, _tmp29_);
							_tmp30_ = self->priv->board;
							_tmp30__length1 = self->priv->board_length1;
							_tmp30__length2 = self->priv->board_length2;
							_g_object_unref0 (_tmp30_[(x * _tmp30__length2) + y]);
							_tmp30_[(x * _tmp30__length2) + y] = NULL;
						}
					}
				}
			}
		}
	}
	{
		gint x = 0;
		x = 0;
		{
			gboolean _tmp31_ = FALSE;
			_tmp31_ = TRUE;
			while (TRUE) {
				if (!_tmp31_) {
					gint _tmp32_;
					_tmp32_ = x;
					x = _tmp32_ + 1;
				}
				_tmp31_ = FALSE;
				if (!(((guint) x) < size)) {
					break;
				}
				{
					gint y = 0;
					y = 0;
					{
						gboolean _tmp33_ = FALSE;
						_tmp33_ = TRUE;
						while (TRUE) {
							gint32 n = 0;
							GList* _tmp35_;
							Tile* tile = NULL;
							GList* _tmp36_;
							gconstpointer _tmp37_;
							Tile* _tmp38_;
							Tile** _tmp39_;
							gint _tmp39__length1;
							gint _tmp39__length2;
							Tile* _tmp40_;
							Tile* _tmp41_;
							Tile* _tmp42_;
							if (!_tmp33_) {
								gint _tmp34_;
								_tmp34_ = y;
								y = _tmp34_ + 1;
							}
							_tmp33_ = FALSE;
							if (!(((guint) y) < size)) {
								break;
							}
							_tmp35_ = tiles;
							n = g_random_int_range ((gint32) 0, (gint32) g_list_length (_tmp35_));
							_tmp36_ = tiles;
							_tmp37_ = g_list_nth_data (_tmp36_, (guint) n);
							_tmp38_ = _g_object_ref0 ((Tile*) _tmp37_);
							tile = _tmp38_;
							_tmp39_ = self->priv->board;
							_tmp39__length1 = self->priv->board_length1;
							_tmp39__length2 = self->priv->board_length2;
							_tmp40_ = tile;
							_tmp41_ = _g_object_ref0 (_tmp40_);
							_g_object_unref0 (_tmp39_[((x + size) * _tmp39__length2) + y]);
							_tmp39_[((x + size) * _tmp39__length2) + y] = _tmp41_;
							_tmp42_ = tile;
							tiles = g_list_remove (tiles, _tmp42_);
							_g_object_unref0 (tile);
						}
					}
				}
			}
		}
	}
	puzzle_start_clock (self);
	(tiles == NULL) ? NULL : (tiles = (_g_list_free__g_object_unref0_ (tiles), NULL));
	return self;
}

Puzzle*
puzzle_new (guint size)
{
	return puzzle_construct (TYPE_PUZZLE, size);
}

Tile*
puzzle_get_tile (Puzzle* self,
                 guint x,
                 guint y)
{
	Tile** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	Tile* _tmp1_;
	Tile* _tmp2_;
	Tile* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->board;
	_tmp0__length1 = self->priv->board_length1;
	_tmp0__length2 = self->priv->board_length2;
	_tmp1_ = _tmp0_[(x * _tmp0__length2) + y];
	_tmp2_ = _g_object_ref0 (_tmp1_);
	result = _tmp2_;
	return result;
}

void
puzzle_get_tile_location (Puzzle* self,
                          Tile* tile,
                          guint* x,
                          guint* y)
{
	guint _vala_x = 0U;
	guint _vala_y = 0U;
	g_return_if_fail (self != NULL);
	g_return_if_fail (tile != NULL);
	_vala_y = (guint) 0;
	_vala_x = _vala_y;
	{
		gboolean _tmp0_ = FALSE;
		_vala_x = (guint) 0;
		_tmp0_ = TRUE;
		while (TRUE) {
			guint _tmp2_;
			guint _tmp3_;
			if (!_tmp0_) {
				guint _tmp1_;
				_tmp1_ = _vala_x;
				_vala_x = _tmp1_ + 1;
			}
			_tmp0_ = FALSE;
			_tmp2_ = puzzle_get_size (self);
			_tmp3_ = _tmp2_;
			if (!(_vala_x < (_tmp3_ * 2))) {
				break;
			}
			{
				gboolean _tmp4_ = FALSE;
				_vala_y = (guint) 0;
				_tmp4_ = TRUE;
				while (TRUE) {
					guint _tmp6_;
					guint _tmp7_;
					Tile** _tmp8_;
					gint _tmp8__length1;
					gint _tmp8__length2;
					Tile* _tmp9_;
					if (!_tmp4_) {
						guint _tmp5_;
						_tmp5_ = _vala_y;
						_vala_y = _tmp5_ + 1;
					}
					_tmp4_ = FALSE;
					_tmp6_ = puzzle_get_size (self);
					_tmp7_ = _tmp6_;
					if (!(_vala_y < _tmp7_)) {
						break;
					}
					_tmp8_ = self->priv->board;
					_tmp8__length1 = self->priv->board_length1;
					_tmp8__length2 = self->priv->board_length2;
					_tmp9_ = _tmp8_[(_vala_x * _tmp8__length2) + _vala_y];
					if (_tmp9_ == tile) {
						if (x) {
							*x = _vala_x;
						}
						if (y) {
							*y = _vala_y;
						}
						return;
					}
				}
			}
		}
	}
	if (x) {
		*x = _vala_x;
	}
	if (y) {
		*y = _vala_y;
	}
}

gboolean
puzzle_tile_fits (Puzzle* self,
                  guint x0,
                  guint y0,
                  guint x1,
                  guint y1)
{
	Tile* tile = NULL;
	Tile** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	Tile* _tmp1_;
	Tile* _tmp2_;
	Tile* _tmp3_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp13_ = FALSE;
	gboolean _tmp14_ = FALSE;
	gboolean _tmp15_ = FALSE;
	guint _tmp16_;
	guint _tmp17_;
	gboolean _tmp24_ = FALSE;
	gboolean _tmp25_ = FALSE;
	gboolean _tmp26_ = FALSE;
	gboolean _tmp33_ = FALSE;
	gboolean _tmp34_ = FALSE;
	gboolean _tmp35_ = FALSE;
	guint _tmp36_;
	guint _tmp37_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->board;
	_tmp0__length1 = self->priv->board_length1;
	_tmp0__length2 = self->priv->board_length2;
	_tmp1_ = _tmp0_[(x0 * _tmp0__length2) + y0];
	_tmp2_ = _g_object_ref0 (_tmp1_);
	tile = _tmp2_;
	_tmp3_ = tile;
	if (_tmp3_ == NULL) {
		result = FALSE;
		_g_object_unref0 (tile);
		return result;
	}
	if (x1 > ((guint) 0)) {
		gboolean _tmp7_ = FALSE;
		if ((x1 - 1) == x0) {
			_tmp7_ = y1 == y0;
		} else {
			_tmp7_ = FALSE;
		}
		_tmp6_ = !_tmp7_;
	} else {
		_tmp6_ = FALSE;
	}
	if (_tmp6_) {
		Tile** _tmp8_;
		gint _tmp8__length1;
		gint _tmp8__length2;
		Tile* _tmp9_;
		_tmp8_ = self->priv->board;
		_tmp8__length1 = self->priv->board_length1;
		_tmp8__length2 = self->priv->board_length2;
		_tmp9_ = _tmp8_[((x1 - 1) * _tmp8__length2) + y1];
		_tmp5_ = _tmp9_ != NULL;
	} else {
		_tmp5_ = FALSE;
	}
	if (_tmp5_) {
		Tile** _tmp10_;
		gint _tmp10__length1;
		gint _tmp10__length2;
		Tile* _tmp11_;
		Tile* _tmp12_;
		_tmp10_ = self->priv->board;
		_tmp10__length1 = self->priv->board_length1;
		_tmp10__length2 = self->priv->board_length2;
		_tmp11_ = _tmp10_[((x1 - 1) * _tmp10__length2) + y1];
		_tmp12_ = tile;
		_tmp4_ = _tmp11_->east != _tmp12_->west;
	} else {
		_tmp4_ = FALSE;
	}
	if (_tmp4_) {
		result = FALSE;
		_g_object_unref0 (tile);
		return result;
	}
	_tmp16_ = puzzle_get_size (self);
	_tmp17_ = _tmp16_;
	if (x1 < (_tmp17_ - 1)) {
		gboolean _tmp18_ = FALSE;
		if ((x1 + 1) == x0) {
			_tmp18_ = y1 == y0;
		} else {
			_tmp18_ = FALSE;
		}
		_tmp15_ = !_tmp18_;
	} else {
		_tmp15_ = FALSE;
	}
	if (_tmp15_) {
		Tile** _tmp19_;
		gint _tmp19__length1;
		gint _tmp19__length2;
		Tile* _tmp20_;
		_tmp19_ = self->priv->board;
		_tmp19__length1 = self->priv->board_length1;
		_tmp19__length2 = self->priv->board_length2;
		_tmp20_ = _tmp19_[((x1 + 1) * _tmp19__length2) + y1];
		_tmp14_ = _tmp20_ != NULL;
	} else {
		_tmp14_ = FALSE;
	}
	if (_tmp14_) {
		Tile** _tmp21_;
		gint _tmp21__length1;
		gint _tmp21__length2;
		Tile* _tmp22_;
		Tile* _tmp23_;
		_tmp21_ = self->priv->board;
		_tmp21__length1 = self->priv->board_length1;
		_tmp21__length2 = self->priv->board_length2;
		_tmp22_ = _tmp21_[((x1 + 1) * _tmp21__length2) + y1];
		_tmp23_ = tile;
		_tmp13_ = _tmp22_->west != _tmp23_->east;
	} else {
		_tmp13_ = FALSE;
	}
	if (_tmp13_) {
		result = FALSE;
		_g_object_unref0 (tile);
		return result;
	}
	if (y1 > ((guint) 0)) {
		gboolean _tmp27_ = FALSE;
		if (x1 == x0) {
			_tmp27_ = (y1 - 1) == y0;
		} else {
			_tmp27_ = FALSE;
		}
		_tmp26_ = !_tmp27_;
	} else {
		_tmp26_ = FALSE;
	}
	if (_tmp26_) {
		Tile** _tmp28_;
		gint _tmp28__length1;
		gint _tmp28__length2;
		Tile* _tmp29_;
		_tmp28_ = self->priv->board;
		_tmp28__length1 = self->priv->board_length1;
		_tmp28__length2 = self->priv->board_length2;
		_tmp29_ = _tmp28_[(x1 * _tmp28__length2) + (y1 - 1)];
		_tmp25_ = _tmp29_ != NULL;
	} else {
		_tmp25_ = FALSE;
	}
	if (_tmp25_) {
		Tile** _tmp30_;
		gint _tmp30__length1;
		gint _tmp30__length2;
		Tile* _tmp31_;
		Tile* _tmp32_;
		_tmp30_ = self->priv->board;
		_tmp30__length1 = self->priv->board_length1;
		_tmp30__length2 = self->priv->board_length2;
		_tmp31_ = _tmp30_[(x1 * _tmp30__length2) + (y1 - 1)];
		_tmp32_ = tile;
		_tmp24_ = _tmp31_->south != _tmp32_->north;
	} else {
		_tmp24_ = FALSE;
	}
	if (_tmp24_) {
		result = FALSE;
		_g_object_unref0 (tile);
		return result;
	}
	_tmp36_ = puzzle_get_size (self);
	_tmp37_ = _tmp36_;
	if (y1 < (_tmp37_ - 1)) {
		gboolean _tmp38_ = FALSE;
		if (x1 == x0) {
			_tmp38_ = (y1 + 1) == y0;
		} else {
			_tmp38_ = FALSE;
		}
		_tmp35_ = !_tmp38_;
	} else {
		_tmp35_ = FALSE;
	}
	if (_tmp35_) {
		Tile** _tmp39_;
		gint _tmp39__length1;
		gint _tmp39__length2;
		Tile* _tmp40_;
		_tmp39_ = self->priv->board;
		_tmp39__length1 = self->priv->board_length1;
		_tmp39__length2 = self->priv->board_length2;
		_tmp40_ = _tmp39_[(x1 * _tmp39__length2) + (y1 + 1)];
		_tmp34_ = _tmp40_ != NULL;
	} else {
		_tmp34_ = FALSE;
	}
	if (_tmp34_) {
		Tile** _tmp41_;
		gint _tmp41__length1;
		gint _tmp41__length2;
		Tile* _tmp42_;
		Tile* _tmp43_;
		_tmp41_ = self->priv->board;
		_tmp41__length1 = self->priv->board_length1;
		_tmp41__length2 = self->priv->board_length2;
		_tmp42_ = _tmp41_[(x1 * _tmp41__length2) + (y1 + 1)];
		_tmp43_ = tile;
		_tmp33_ = _tmp42_->north != _tmp43_->south;
	} else {
		_tmp33_ = FALSE;
	}
	if (_tmp33_) {
		result = FALSE;
		_g_object_unref0 (tile);
		return result;
	}
	result = TRUE;
	_g_object_unref0 (tile);
	return result;
}

gboolean
puzzle_can_switch (Puzzle* self,
                   guint x0,
                   guint y0,
                   guint x1,
                   guint y1)
{
	gboolean _tmp0_ = FALSE;
	Tile* t0 = NULL;
	Tile** _tmp1_;
	gint _tmp1__length1;
	gint _tmp1__length2;
	Tile* _tmp2_;
	Tile* _tmp3_;
	Tile* t1 = NULL;
	Tile** _tmp4_;
	gint _tmp4__length1;
	gint _tmp4__length2;
	Tile* _tmp5_;
	Tile* _tmp6_;
	gboolean _tmp7_ = FALSE;
	Tile* _tmp8_;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_ = FALSE;
	Tile* _tmp12_;
	gboolean _tmp15_ = FALSE;
	gboolean _tmp16_ = FALSE;
	Tile* _tmp17_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	if (x0 == x1) {
		_tmp0_ = y0 == y1;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		result = FALSE;
		return result;
	}
	_tmp1_ = self->priv->board;
	_tmp1__length1 = self->priv->board_length1;
	_tmp1__length2 = self->priv->board_length2;
	_tmp2_ = _tmp1_[(x0 * _tmp1__length2) + y0];
	_tmp3_ = _g_object_ref0 (_tmp2_);
	t0 = _tmp3_;
	_tmp4_ = self->priv->board;
	_tmp4__length1 = self->priv->board_length1;
	_tmp4__length2 = self->priv->board_length2;
	_tmp5_ = _tmp4_[(x1 * _tmp4__length2) + y1];
	_tmp6_ = _g_object_ref0 (_tmp5_);
	t1 = _tmp6_;
	_tmp8_ = t0;
	if (_tmp8_ == NULL) {
		Tile* _tmp9_;
		_tmp9_ = t1;
		_tmp7_ = _tmp9_ == NULL;
	} else {
		_tmp7_ = FALSE;
	}
	if (_tmp7_) {
		result = FALSE;
		_g_object_unref0 (t1);
		_g_object_unref0 (t0);
		return result;
	}
	_tmp12_ = t0;
	if (_tmp12_ != NULL) {
		guint _tmp13_;
		guint _tmp14_;
		_tmp13_ = puzzle_get_size (self);
		_tmp14_ = _tmp13_;
		_tmp11_ = x1 < _tmp14_;
	} else {
		_tmp11_ = FALSE;
	}
	if (_tmp11_) {
		_tmp10_ = !puzzle_tile_fits (self, x0, y0, x1, y1);
	} else {
		_tmp10_ = FALSE;
	}
	if (_tmp10_) {
		result = FALSE;
		_g_object_unref0 (t1);
		_g_object_unref0 (t0);
		return result;
	}
	_tmp17_ = t1;
	if (_tmp17_ != NULL) {
		guint _tmp18_;
		guint _tmp19_;
		_tmp18_ = puzzle_get_size (self);
		_tmp19_ = _tmp18_;
		_tmp16_ = x0 < _tmp19_;
	} else {
		_tmp16_ = FALSE;
	}
	if (_tmp16_) {
		_tmp15_ = !puzzle_tile_fits (self, x1, y1, x0, y0);
	} else {
		_tmp15_ = FALSE;
	}
	if (_tmp15_) {
		result = FALSE;
		_g_object_unref0 (t1);
		_g_object_unref0 (t0);
		return result;
	}
	result = TRUE;
	_g_object_unref0 (t1);
	_g_object_unref0 (t0);
	return result;
}

void
puzzle_switch_tiles (Puzzle* self,
                     guint x0,
                     guint y0,
                     guint x1,
                     guint y1)
{
	gboolean _tmp0_ = FALSE;
	Tile* t0 = NULL;
	Tile** _tmp1_;
	gint _tmp1__length1;
	gint _tmp1__length2;
	Tile* _tmp2_;
	Tile* _tmp3_;
	Tile* t1 = NULL;
	Tile** _tmp4_;
	gint _tmp4__length1;
	gint _tmp4__length2;
	Tile* _tmp5_;
	Tile* _tmp6_;
	Tile** _tmp7_;
	gint _tmp7__length1;
	gint _tmp7__length2;
	Tile* _tmp8_;
	Tile* _tmp9_;
	Tile** _tmp10_;
	gint _tmp10__length1;
	gint _tmp10__length2;
	Tile* _tmp11_;
	Tile* _tmp12_;
	Tile* _tmp13_;
	Tile* _tmp15_;
	gboolean _tmp17_;
	gboolean _tmp18_;
	g_return_if_fail (self != NULL);
	if (x0 == x1) {
		_tmp0_ = y0 == y1;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		return;
	}
	_tmp1_ = self->priv->board;
	_tmp1__length1 = self->priv->board_length1;
	_tmp1__length2 = self->priv->board_length2;
	_tmp2_ = _tmp1_[(x0 * _tmp1__length2) + y0];
	_tmp3_ = _g_object_ref0 (_tmp2_);
	t0 = _tmp3_;
	_tmp4_ = self->priv->board;
	_tmp4__length1 = self->priv->board_length1;
	_tmp4__length2 = self->priv->board_length2;
	_tmp5_ = _tmp4_[(x1 * _tmp4__length2) + y1];
	_tmp6_ = _g_object_ref0 (_tmp5_);
	t1 = _tmp6_;
	_tmp7_ = self->priv->board;
	_tmp7__length1 = self->priv->board_length1;
	_tmp7__length2 = self->priv->board_length2;
	_tmp8_ = t1;
	_tmp9_ = _g_object_ref0 (_tmp8_);
	_g_object_unref0 (_tmp7_[(x0 * _tmp7__length2) + y0]);
	_tmp7_[(x0 * _tmp7__length2) + y0] = _tmp9_;
	_tmp10_ = self->priv->board;
	_tmp10__length1 = self->priv->board_length1;
	_tmp10__length2 = self->priv->board_length2;
	_tmp11_ = t0;
	_tmp12_ = _g_object_ref0 (_tmp11_);
	_g_object_unref0 (_tmp10_[(x1 * _tmp10__length2) + y1]);
	_tmp10_[(x1 * _tmp10__length2) + y1] = _tmp12_;
	_tmp13_ = t0;
	if (_tmp13_ != NULL) {
		Tile* _tmp14_;
		_tmp14_ = t0;
		g_signal_emit (self, puzzle_signals[PUZZLE_TILE_MOVED_SIGNAL], 0, _tmp14_, x1, y1);
	}
	_tmp15_ = t1;
	if (_tmp15_ != NULL) {
		Tile* _tmp16_;
		_tmp16_ = t1;
		g_signal_emit (self, puzzle_signals[PUZZLE_TILE_MOVED_SIGNAL], 0, _tmp16_, x0, y0);
	}
	_tmp17_ = puzzle_get_is_solved (self);
	_tmp18_ = _tmp17_;
	if (_tmp18_) {
		puzzle_stop_clock (self);
		g_signal_emit (self, puzzle_signals[PUZZLE_SOLVED_SIGNAL], 0);
	}
	_g_object_unref0 (t1);
	_g_object_unref0 (t0);
}

void
puzzle_move_up (Puzzle* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = puzzle_get_can_move_up (self);
	_tmp1_ = _tmp0_;
	if (!_tmp1_) {
		return;
	}
	{
		gint y = 0;
		y = 1;
		{
			gboolean _tmp2_ = FALSE;
			_tmp2_ = TRUE;
			while (TRUE) {
				guint _tmp4_;
				guint _tmp5_;
				if (!_tmp2_) {
					gint _tmp3_;
					_tmp3_ = y;
					y = _tmp3_ + 1;
				}
				_tmp2_ = FALSE;
				_tmp4_ = puzzle_get_size (self);
				_tmp5_ = _tmp4_;
				if (!(((guint) y) < _tmp5_)) {
					break;
				}
				{
					gint x = 0;
					x = 0;
					{
						gboolean _tmp6_ = FALSE;
						_tmp6_ = TRUE;
						while (TRUE) {
							guint _tmp8_;
							guint _tmp9_;
							if (!_tmp6_) {
								gint _tmp7_;
								_tmp7_ = x;
								x = _tmp7_ + 1;
							}
							_tmp6_ = FALSE;
							_tmp8_ = puzzle_get_size (self);
							_tmp9_ = _tmp8_;
							if (!(((guint) x) < _tmp9_)) {
								break;
							}
							puzzle_switch_tiles (self, (guint) x, (guint) y, (guint) x, (guint) (y - 1));
						}
					}
				}
			}
		}
	}
}

void
puzzle_move_down (Puzzle* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = puzzle_get_can_move_down (self);
	_tmp1_ = _tmp0_;
	if (!_tmp1_) {
		return;
	}
	{
		gint y = 0;
		guint _tmp2_;
		guint _tmp3_;
		_tmp2_ = puzzle_get_size (self);
		_tmp3_ = _tmp2_;
		y = ((gint) _tmp3_) - 2;
		{
			gboolean _tmp4_ = FALSE;
			_tmp4_ = TRUE;
			while (TRUE) {
				if (!_tmp4_) {
					gint _tmp5_;
					_tmp5_ = y;
					y = _tmp5_ - 1;
				}
				_tmp4_ = FALSE;
				if (!(y >= 0)) {
					break;
				}
				{
					gint x = 0;
					x = 0;
					{
						gboolean _tmp6_ = FALSE;
						_tmp6_ = TRUE;
						while (TRUE) {
							guint _tmp8_;
							guint _tmp9_;
							if (!_tmp6_) {
								gint _tmp7_;
								_tmp7_ = x;
								x = _tmp7_ + 1;
							}
							_tmp6_ = FALSE;
							_tmp8_ = puzzle_get_size (self);
							_tmp9_ = _tmp8_;
							if (!(((guint) x) < _tmp9_)) {
								break;
							}
							puzzle_switch_tiles (self, (guint) x, (guint) y, (guint) x, (guint) (y + 1));
						}
					}
				}
			}
		}
	}
}

void
puzzle_move_left (Puzzle* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = puzzle_get_can_move_left (self);
	_tmp1_ = _tmp0_;
	if (!_tmp1_) {
		return;
	}
	{
		gint x = 0;
		x = 1;
		{
			gboolean _tmp2_ = FALSE;
			_tmp2_ = TRUE;
			while (TRUE) {
				guint _tmp4_;
				guint _tmp5_;
				if (!_tmp2_) {
					gint _tmp3_;
					_tmp3_ = x;
					x = _tmp3_ + 1;
				}
				_tmp2_ = FALSE;
				_tmp4_ = puzzle_get_size (self);
				_tmp5_ = _tmp4_;
				if (!(((guint) x) < _tmp5_)) {
					break;
				}
				{
					gint y = 0;
					y = 0;
					{
						gboolean _tmp6_ = FALSE;
						_tmp6_ = TRUE;
						while (TRUE) {
							guint _tmp8_;
							guint _tmp9_;
							if (!_tmp6_) {
								gint _tmp7_;
								_tmp7_ = y;
								y = _tmp7_ + 1;
							}
							_tmp6_ = FALSE;
							_tmp8_ = puzzle_get_size (self);
							_tmp9_ = _tmp8_;
							if (!(((guint) y) < _tmp9_)) {
								break;
							}
							puzzle_switch_tiles (self, (guint) x, (guint) y, (guint) (x - 1), (guint) y);
						}
					}
				}
			}
		}
	}
}

void
puzzle_move_right (Puzzle* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = puzzle_get_can_move_right (self);
	_tmp1_ = _tmp0_;
	if (!_tmp1_) {
		return;
	}
	{
		gint x = 0;
		guint _tmp2_;
		guint _tmp3_;
		_tmp2_ = puzzle_get_size (self);
		_tmp3_ = _tmp2_;
		x = ((gint) _tmp3_) - 2;
		{
			gboolean _tmp4_ = FALSE;
			_tmp4_ = TRUE;
			while (TRUE) {
				if (!_tmp4_) {
					gint _tmp5_;
					_tmp5_ = x;
					x = _tmp5_ - 1;
				}
				_tmp4_ = FALSE;
				if (!(x >= 0)) {
					break;
				}
				{
					gint y = 0;
					y = 0;
					{
						gboolean _tmp6_ = FALSE;
						_tmp6_ = TRUE;
						while (TRUE) {
							guint _tmp8_;
							guint _tmp9_;
							if (!_tmp6_) {
								gint _tmp7_;
								_tmp7_ = y;
								y = _tmp7_ + 1;
							}
							_tmp6_ = FALSE;
							_tmp8_ = puzzle_get_size (self);
							_tmp9_ = _tmp8_;
							if (!(((guint) y) < _tmp9_)) {
								break;
							}
							puzzle_switch_tiles (self, (guint) x, (guint) y, (guint) (x + 1), (guint) y);
						}
					}
				}
			}
		}
	}
}

void
puzzle_solve (Puzzle* self)
{
	GList* wrong_tiles = NULL;
	GList* _tmp19_;
	g_return_if_fail (self != NULL);
	wrong_tiles = NULL;
	{
		gint x = 0;
		x = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				guint _tmp2_;
				guint _tmp3_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = x;
					x = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = puzzle_get_size (self);
				_tmp3_ = _tmp2_;
				if (!(((guint) x) < (_tmp3_ * 2))) {
					break;
				}
				{
					gint y = 0;
					y = 0;
					{
						gboolean _tmp4_ = FALSE;
						_tmp4_ = TRUE;
						while (TRUE) {
							guint _tmp6_;
							guint _tmp7_;
							Tile* tile = NULL;
							Tile** _tmp8_;
							gint _tmp8__length1;
							gint _tmp8__length2;
							Tile* _tmp9_;
							Tile* _tmp10_;
							gboolean _tmp11_ = FALSE;
							Tile* _tmp12_;
							Tile** _tmp18_;
							gint _tmp18__length1;
							gint _tmp18__length2;
							if (!_tmp4_) {
								gint _tmp5_;
								_tmp5_ = y;
								y = _tmp5_ + 1;
							}
							_tmp4_ = FALSE;
							_tmp6_ = puzzle_get_size (self);
							_tmp7_ = _tmp6_;
							if (!(((guint) y) < _tmp7_)) {
								break;
							}
							_tmp8_ = self->priv->board;
							_tmp8__length1 = self->priv->board_length1;
							_tmp8__length2 = self->priv->board_length2;
							_tmp9_ = _tmp8_[(x * _tmp8__length2) + y];
							_tmp10_ = _g_object_ref0 (_tmp9_);
							tile = _tmp10_;
							_tmp12_ = tile;
							if (_tmp12_ != NULL) {
								gboolean _tmp13_ = FALSE;
								Tile* _tmp14_;
								_tmp14_ = tile;
								if (_tmp14_->x != ((guint) x)) {
									_tmp13_ = TRUE;
								} else {
									Tile* _tmp15_;
									_tmp15_ = tile;
									_tmp13_ = _tmp15_->y != ((guint) y);
								}
								_tmp11_ = _tmp13_;
							} else {
								_tmp11_ = FALSE;
							}
							if (_tmp11_) {
								Tile* _tmp16_;
								Tile* _tmp17_;
								_tmp16_ = tile;
								_tmp17_ = _g_object_ref0 (_tmp16_);
								wrong_tiles = g_list_append (wrong_tiles, _tmp17_);
							}
							_tmp18_ = self->priv->board;
							_tmp18__length1 = self->priv->board_length1;
							_tmp18__length2 = self->priv->board_length2;
							_g_object_unref0 (_tmp18_[(x * _tmp18__length2) + y]);
							_tmp18_[(x * _tmp18__length2) + y] = NULL;
							_g_object_unref0 (tile);
						}
					}
				}
			}
		}
	}
	_tmp19_ = wrong_tiles;
	{
		GList* tile_collection = NULL;
		GList* tile_it = NULL;
		tile_collection = _tmp19_;
		for (tile_it = tile_collection; tile_it != NULL; tile_it = tile_it->next) {
			Tile* _tmp20_;
			Tile* tile = NULL;
			_tmp20_ = _g_object_ref0 ((Tile*) tile_it->data);
			tile = _tmp20_;
			{
				Tile** _tmp21_;
				gint _tmp21__length1;
				gint _tmp21__length2;
				Tile* _tmp22_;
				Tile* _tmp23_;
				Tile* _tmp24_;
				Tile* _tmp25_;
				Tile* _tmp26_;
				Tile* _tmp27_;
				Tile* _tmp28_;
				_tmp21_ = self->priv->board;
				_tmp21__length1 = self->priv->board_length1;
				_tmp21__length2 = self->priv->board_length2;
				_tmp22_ = tile;
				_tmp23_ = tile;
				_tmp24_ = tile;
				_tmp25_ = _g_object_ref0 (_tmp24_);
				_g_object_unref0 (_tmp21_[(_tmp22_->x * _tmp21__length2) + _tmp23_->y]);
				_tmp21_[(_tmp22_->x * _tmp21__length2) + _tmp23_->y] = _tmp25_;
				_tmp26_ = tile;
				_tmp27_ = tile;
				_tmp28_ = tile;
				g_signal_emit (self, puzzle_signals[PUZZLE_TILE_MOVED_SIGNAL], 0, _tmp26_, _tmp27_->x, _tmp28_->y);
				_g_object_unref0 (tile);
			}
		}
	}
	puzzle_stop_clock (self);
	(wrong_tiles == NULL) ? NULL : (wrong_tiles = (_g_list_free__g_object_unref0_ (wrong_tiles), NULL));
}

static void
puzzle_start_clock (Puzzle* self)
{
	GTimer* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->clock;
	if (_tmp0_ == NULL) {
		GTimer* _tmp1_;
		_tmp1_ = g_timer_new ();
		_g_timer_destroy0 (self->priv->clock);
		self->priv->clock = _tmp1_;
	}
	puzzle_timeout_cb (self);
}

static void
puzzle_stop_clock (Puzzle* self)
{
	GTimer* _tmp0_;
	GTimer* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->clock;
	if (_tmp0_ == NULL) {
		return;
	}
	if (self->priv->clock_timeout != ((guint) 0)) {
		g_source_remove (self->priv->clock_timeout);
	}
	self->priv->clock_timeout = (guint) 0;
	_tmp1_ = self->priv->clock;
	g_timer_stop (_tmp1_);
	g_signal_emit (self, puzzle_signals[PUZZLE_TICK_SIGNAL], 0);
}

static void
puzzle_continue_clock (Puzzle* self)
{
	GTimer* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->clock;
	if (_tmp0_ == NULL) {
		GTimer* _tmp1_;
		_tmp1_ = g_timer_new ();
		_g_timer_destroy0 (self->priv->clock);
		self->priv->clock = _tmp1_;
	} else {
		GTimer* _tmp2_;
		_tmp2_ = self->priv->clock;
		g_timer_continue (_tmp2_);
	}
	puzzle_timeout_cb (self);
}

static gboolean
_puzzle_timeout_cb_gsource_func (gpointer self)
{
	gboolean result;
	result = puzzle_timeout_cb ((Puzzle*) self);
	return result;
}

static gboolean
puzzle_timeout_cb (Puzzle* self)
{
	gdouble elapsed = 0.0;
	GTimer* _tmp0_;
	gint next = 0;
	gdouble wait = 0.0;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->clock;
	elapsed = g_timer_elapsed (_tmp0_, NULL);
	next = (gint) (elapsed + 1.0);
	wait = next - elapsed;
	self->priv->clock_timeout = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) ((gint) (wait * 1000)), _puzzle_timeout_cb_gsource_func, g_object_ref (self), g_object_unref);
	g_signal_emit (self, puzzle_signals[PUZZLE_TICK_SIGNAL], 0);
	result = FALSE;
	return result;
}

guint
puzzle_get_size (Puzzle* self)
{
	guint result;
	g_return_val_if_fail (self != NULL, 0U);
	result = self->priv->_size;
	return result;
}

gdouble
puzzle_get_elapsed (Puzzle* self)
{
	gdouble result;
	GTimer* _tmp0_;
	GTimer* _tmp1_;
	g_return_val_if_fail (self != NULL, 0.0);
	_tmp0_ = self->priv->clock;
	if (_tmp0_ == NULL) {
		result = 0.0;
		return result;
	}
	_tmp1_ = self->priv->clock;
	result = self->priv->clock_elapsed + g_timer_elapsed (_tmp1_, NULL);
	return result;
}

gboolean
puzzle_get_paused (Puzzle* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_paused;
	return result;
}

void
puzzle_set_paused (Puzzle* self,
                   gboolean value)
{
	GTimer* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_paused = value;
	_tmp0_ = self->priv->clock;
	if (_tmp0_ != NULL) {
		if (value) {
			puzzle_stop_clock (self);
		} else {
			puzzle_continue_clock (self);
		}
	}
	g_signal_emit (self, puzzle_signals[PUZZLE_PAUSED_CHANGED_SIGNAL], 0);
	g_object_notify_by_pspec ((GObject *) self, puzzle_properties[PUZZLE_PAUSED_PROPERTY]);
}

gboolean
puzzle_get_is_solved (Puzzle* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	{
		gint x = 0;
		x = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				guint _tmp2_;
				guint _tmp3_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = x;
					x = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = puzzle_get_size (self);
				_tmp3_ = _tmp2_;
				if (!(((guint) x) < _tmp3_)) {
					break;
				}
				{
					gint y = 0;
					y = 0;
					{
						gboolean _tmp4_ = FALSE;
						_tmp4_ = TRUE;
						while (TRUE) {
							guint _tmp6_;
							guint _tmp7_;
							Tile* tile = NULL;
							Tile** _tmp8_;
							gint _tmp8__length1;
							gint _tmp8__length2;
							Tile* _tmp9_;
							Tile* _tmp10_;
							Tile* _tmp11_;
							if (!_tmp4_) {
								gint _tmp5_;
								_tmp5_ = y;
								y = _tmp5_ + 1;
							}
							_tmp4_ = FALSE;
							_tmp6_ = puzzle_get_size (self);
							_tmp7_ = _tmp6_;
							if (!(((guint) y) < _tmp7_)) {
								break;
							}
							_tmp8_ = self->priv->board;
							_tmp8__length1 = self->priv->board_length1;
							_tmp8__length2 = self->priv->board_length2;
							_tmp9_ = _tmp8_[(x * _tmp8__length2) + y];
							_tmp10_ = _g_object_ref0 (_tmp9_);
							tile = _tmp10_;
							_tmp11_ = tile;
							if (_tmp11_ == NULL) {
								result = FALSE;
								_g_object_unref0 (tile);
								return result;
							}
							_g_object_unref0 (tile);
						}
					}
				}
			}
		}
	}
	result = TRUE;
	return result;
}

gboolean
puzzle_get_can_move_up (Puzzle* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	{
		gint x = 0;
		x = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				guint _tmp2_;
				guint _tmp3_;
				Tile** _tmp4_;
				gint _tmp4__length1;
				gint _tmp4__length2;
				Tile* _tmp5_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = x;
					x = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = puzzle_get_size (self);
				_tmp3_ = _tmp2_;
				if (!(((guint) x) < _tmp3_)) {
					break;
				}
				_tmp4_ = self->priv->board;
				_tmp4__length1 = self->priv->board_length1;
				_tmp4__length2 = self->priv->board_length2;
				_tmp5_ = _tmp4_[(x * _tmp4__length2) + 0];
				if (_tmp5_ != NULL) {
					result = FALSE;
					return result;
				}
			}
		}
	}
	result = TRUE;
	return result;
}

gboolean
puzzle_get_can_move_down (Puzzle* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	{
		gint x = 0;
		x = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				guint _tmp2_;
				guint _tmp3_;
				Tile** _tmp4_;
				gint _tmp4__length1;
				gint _tmp4__length2;
				guint _tmp5_;
				guint _tmp6_;
				Tile* _tmp7_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = x;
					x = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = puzzle_get_size (self);
				_tmp3_ = _tmp2_;
				if (!(((guint) x) < _tmp3_)) {
					break;
				}
				_tmp4_ = self->priv->board;
				_tmp4__length1 = self->priv->board_length1;
				_tmp4__length2 = self->priv->board_length2;
				_tmp5_ = puzzle_get_size (self);
				_tmp6_ = _tmp5_;
				_tmp7_ = _tmp4_[(x * _tmp4__length2) + (_tmp6_ - 1)];
				if (_tmp7_ != NULL) {
					result = FALSE;
					return result;
				}
			}
		}
	}
	result = TRUE;
	return result;
}

gboolean
puzzle_get_can_move_left (Puzzle* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	{
		gint y = 0;
		y = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				guint _tmp2_;
				guint _tmp3_;
				Tile** _tmp4_;
				gint _tmp4__length1;
				gint _tmp4__length2;
				Tile* _tmp5_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = y;
					y = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = puzzle_get_size (self);
				_tmp3_ = _tmp2_;
				if (!(((guint) y) < _tmp3_)) {
					break;
				}
				_tmp4_ = self->priv->board;
				_tmp4__length1 = self->priv->board_length1;
				_tmp4__length2 = self->priv->board_length2;
				_tmp5_ = _tmp4_[(0 * _tmp4__length2) + y];
				if (_tmp5_ != NULL) {
					result = FALSE;
					return result;
				}
			}
		}
	}
	result = TRUE;
	return result;
}

gboolean
puzzle_get_can_move_right (Puzzle* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	{
		gint y = 0;
		y = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				guint _tmp2_;
				guint _tmp3_;
				Tile** _tmp4_;
				gint _tmp4__length1;
				gint _tmp4__length2;
				guint _tmp5_;
				guint _tmp6_;
				Tile* _tmp7_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = y;
					y = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = puzzle_get_size (self);
				_tmp3_ = _tmp2_;
				if (!(((guint) y) < _tmp3_)) {
					break;
				}
				_tmp4_ = self->priv->board;
				_tmp4__length1 = self->priv->board_length1;
				_tmp4__length2 = self->priv->board_length2;
				_tmp5_ = puzzle_get_size (self);
				_tmp6_ = _tmp5_;
				_tmp7_ = _tmp4_[((_tmp6_ - 1) * _tmp4__length2) + y];
				if (_tmp7_ != NULL) {
					result = FALSE;
					return result;
				}
			}
		}
	}
	result = TRUE;
	return result;
}

static void
g_cclosure_user_marshal_VOID__OBJECT_UINT_UINT (GClosure * closure,
                                                GValue * return_value,
                                                guint n_param_values,
                                                const GValue * param_values,
                                                gpointer invocation_hint,
                                                gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_UINT_UINT) (gpointer data1, gpointer arg_1, guint arg_2, guint arg_3, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_UINT_UINT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 4);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__OBJECT_UINT_UINT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_object (param_values + 1), g_value_get_uint (param_values + 2), g_value_get_uint (param_values + 3), data2);
}

static void
puzzle_class_init (PuzzleClass * klass,
                   gpointer klass_data)
{
	puzzle_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &Puzzle_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_puzzle_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_puzzle_set_property;
	G_OBJECT_CLASS (klass)->finalize = puzzle_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), PUZZLE_SIZE_PROPERTY, puzzle_properties[PUZZLE_SIZE_PROPERTY] = g_param_spec_uint ("size", "size", "size", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PUZZLE_ELAPSED_PROPERTY, puzzle_properties[PUZZLE_ELAPSED_PROPERTY] = g_param_spec_double ("elapsed", "elapsed", "elapsed", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PUZZLE_PAUSED_PROPERTY, puzzle_properties[PUZZLE_PAUSED_PROPERTY] = g_param_spec_boolean ("paused", "paused", "paused", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PUZZLE_IS_SOLVED_PROPERTY, puzzle_properties[PUZZLE_IS_SOLVED_PROPERTY] = g_param_spec_boolean ("is-solved", "is-solved", "is-solved", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PUZZLE_CAN_MOVE_UP_PROPERTY, puzzle_properties[PUZZLE_CAN_MOVE_UP_PROPERTY] = g_param_spec_boolean ("can-move-up", "can-move-up", "can-move-up", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PUZZLE_CAN_MOVE_DOWN_PROPERTY, puzzle_properties[PUZZLE_CAN_MOVE_DOWN_PROPERTY] = g_param_spec_boolean ("can-move-down", "can-move-down", "can-move-down", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PUZZLE_CAN_MOVE_LEFT_PROPERTY, puzzle_properties[PUZZLE_CAN_MOVE_LEFT_PROPERTY] = g_param_spec_boolean ("can-move-left", "can-move-left", "can-move-left", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PUZZLE_CAN_MOVE_RIGHT_PROPERTY, puzzle_properties[PUZZLE_CAN_MOVE_RIGHT_PROPERTY] = g_param_spec_boolean ("can-move-right", "can-move-right", "can-move-right", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	puzzle_signals[PUZZLE_TILE_MOVED_SIGNAL] = g_signal_new ("tile-moved", TYPE_PUZZLE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_UINT_UINT, G_TYPE_NONE, 3, TYPE_TILE, G_TYPE_UINT, G_TYPE_UINT);
	puzzle_signals[PUZZLE_SOLVED_SIGNAL] = g_signal_new ("solved", TYPE_PUZZLE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	puzzle_signals[PUZZLE_PAUSED_CHANGED_SIGNAL] = g_signal_new ("paused-changed", TYPE_PUZZLE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	puzzle_signals[PUZZLE_TICK_SIGNAL] = g_signal_new ("tick", TYPE_PUZZLE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}

static void
puzzle_instance_init (Puzzle * self,
                      gpointer klass)
{
	self->priv = puzzle_get_instance_private (self);
	self->priv->_paused = FALSE;
}

static void
puzzle_finalize (GObject * obj)
{
	Puzzle * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PUZZLE, Puzzle);
	self->priv->board = (_vala_array_free (self->priv->board, self->priv->board_length1 * self->priv->board_length2, (GDestroyNotify) g_object_unref), NULL);
	_g_timer_destroy0 (self->priv->clock);
	G_OBJECT_CLASS (puzzle_parent_class)->finalize (obj);
}

GType
puzzle_get_type (void)
{
	static volatile gsize puzzle_type_id__volatile = 0;
	if (g_once_init_enter (&puzzle_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PuzzleClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) puzzle_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Puzzle), 0, (GInstanceInitFunc) puzzle_instance_init, NULL };
		GType puzzle_type_id;
		puzzle_type_id = g_type_register_static (G_TYPE_OBJECT, "Puzzle", &g_define_type_info, 0);
		Puzzle_private_offset = g_type_add_instance_private (puzzle_type_id, sizeof (PuzzlePrivate));
		g_once_init_leave (&puzzle_type_id__volatile, puzzle_type_id);
	}
	return puzzle_type_id__volatile;
}

static void
_vala_puzzle_get_property (GObject * object,
                           guint property_id,
                           GValue * value,
                           GParamSpec * pspec)
{
	Puzzle * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PUZZLE, Puzzle);
	switch (property_id) {
		case PUZZLE_SIZE_PROPERTY:
		g_value_set_uint (value, puzzle_get_size (self));
		break;
		case PUZZLE_ELAPSED_PROPERTY:
		g_value_set_double (value, puzzle_get_elapsed (self));
		break;
		case PUZZLE_PAUSED_PROPERTY:
		g_value_set_boolean (value, puzzle_get_paused (self));
		break;
		case PUZZLE_IS_SOLVED_PROPERTY:
		g_value_set_boolean (value, puzzle_get_is_solved (self));
		break;
		case PUZZLE_CAN_MOVE_UP_PROPERTY:
		g_value_set_boolean (value, puzzle_get_can_move_up (self));
		break;
		case PUZZLE_CAN_MOVE_DOWN_PROPERTY:
		g_value_set_boolean (value, puzzle_get_can_move_down (self));
		break;
		case PUZZLE_CAN_MOVE_LEFT_PROPERTY:
		g_value_set_boolean (value, puzzle_get_can_move_left (self));
		break;
		case PUZZLE_CAN_MOVE_RIGHT_PROPERTY:
		g_value_set_boolean (value, puzzle_get_can_move_right (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_puzzle_set_property (GObject * object,
                           guint property_id,
                           const GValue * value,
                           GParamSpec * pspec)
{
	Puzzle * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PUZZLE, Puzzle);
	switch (property_id) {
		case PUZZLE_PAUSED_PROPERTY:
		puzzle_set_paused (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

