/* theme.c generated by valac 0.46.6, the Vala compiler
 * generated from theme.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * Copyright (C) 2010-2013 Robert Ancell
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 2 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */

#include <glib-object.h>
#include <cairo.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>

#define TYPE_THEME (theme_get_type ())
#define THEME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THEME, Theme))
#define THEME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THEME, ThemeClass))
#define IS_THEME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THEME))
#define IS_THEME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THEME))
#define THEME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THEME, ThemeClass))

typedef struct _Theme Theme;
typedef struct _ThemeClass ThemeClass;
typedef struct _ThemePrivate ThemePrivate;
enum  {
	THEME_0_PROPERTY,
	THEME_NUM_PROPERTIES
};
static GParamSpec* theme_properties[THEME_NUM_PROPERTIES];
#define _cairo_pattern_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_pattern_destroy (var), NULL)))

#define TYPE_TILE (tile_get_type ())
#define TILE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TILE, Tile))
#define TILE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TILE, TileClass))
#define IS_TILE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TILE))
#define IS_TILE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TILE))
#define TILE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TILE, TileClass))

typedef struct _Tile Tile;
typedef struct _TileClass TileClass;
typedef struct _TilePrivate TilePrivate;
#define _g_free0(var) (var = (g_free (var), NULL))

struct _Theme {
	GObject parent_instance;
	ThemePrivate * priv;
};

struct _ThemeClass {
	GObjectClass parent_class;
};

struct _ThemePrivate {
	cairo_pattern_t* tile_colors[10];
	cairo_pattern_t* paused_color;
	cairo_pattern_t* text_colors[10];
};

struct _Tile {
	GObject parent_instance;
	TilePrivate * priv;
	gint north;
	gint west;
	gint east;
	gint south;
	guint x;
	guint y;
};

struct _TileClass {
	GObjectClass parent_class;
};

static gint Theme_private_offset;
static gpointer theme_parent_class = NULL;

GType theme_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Theme, g_object_unref)
Theme* theme_new (void);
Theme* theme_construct (GType object_type);
static cairo_pattern_t* theme_make_color_pattern (Theme* self,
                                           const gchar* color);
static gdouble theme_hex_value (Theme* self,
                         gchar c);
void theme_draw_arrow (Theme* self,
                       cairo_t* context,
                       guint size,
                       guint gap);
void theme_draw_socket (Theme* self,
                        cairo_t* context,
                        guint size);
void theme_draw_paused_tile (Theme* self,
                             cairo_t* context,
                             guint size);
static void theme_draw_tile_background (Theme* self,
                                 cairo_t* context,
                                 guint size,
                                 cairo_pattern_t* north_color,
                                 cairo_pattern_t* east_color,
                                 cairo_pattern_t* south_color,
                                 cairo_pattern_t* west_color);
GType tile_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Tile, g_object_unref)
void theme_draw_tile (Theme* self,
                      cairo_t* context,
                      guint size,
                      Tile* tile);
static void theme_draw_number (Theme* self,
                        cairo_t* context,
                        gdouble x,
                        gdouble y,
                        guint number);
static void theme_finalize (GObject * obj);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
theme_get_instance_private (Theme* self)
{
	return G_STRUCT_MEMBER_P (self, Theme_private_offset);
}

Theme*
theme_construct (GType object_type)
{
	Theme * self = NULL;
	cairo_pattern_t* _tmp0_;
	cairo_pattern_t* _tmp1_;
	cairo_pattern_t* _tmp2_;
	cairo_pattern_t* _tmp3_;
	cairo_pattern_t* _tmp4_;
	cairo_pattern_t* _tmp5_;
	cairo_pattern_t* _tmp6_;
	cairo_pattern_t* _tmp7_;
	cairo_pattern_t* _tmp8_;
	cairo_pattern_t* _tmp9_;
	cairo_pattern_t* _tmp10_;
	cairo_pattern_t* _tmp11_;
	cairo_pattern_t* _tmp12_;
	cairo_pattern_t* _tmp13_;
	cairo_pattern_t* _tmp14_;
	cairo_pattern_t* _tmp15_;
	cairo_pattern_t* _tmp16_;
	cairo_pattern_t* _tmp17_;
	cairo_pattern_t* _tmp18_;
	cairo_pattern_t* _tmp19_;
	cairo_pattern_t* _tmp20_;
	self = (Theme*) g_object_new (object_type, NULL);
	_tmp0_ = theme_make_color_pattern (self, "#000000");
	_cairo_pattern_destroy0 (self->priv->tile_colors[0]);
	self->priv->tile_colors[0] = _tmp0_;
	_tmp1_ = theme_make_color_pattern (self, "#C17D11");
	_cairo_pattern_destroy0 (self->priv->tile_colors[1]);
	self->priv->tile_colors[1] = _tmp1_;
	_tmp2_ = theme_make_color_pattern (self, "#CC0000");
	_cairo_pattern_destroy0 (self->priv->tile_colors[2]);
	self->priv->tile_colors[2] = _tmp2_;
	_tmp3_ = theme_make_color_pattern (self, "#F57900");
	_cairo_pattern_destroy0 (self->priv->tile_colors[3]);
	self->priv->tile_colors[3] = _tmp3_;
	_tmp4_ = theme_make_color_pattern (self, "#EDD400");
	_cairo_pattern_destroy0 (self->priv->tile_colors[4]);
	self->priv->tile_colors[4] = _tmp4_;
	_tmp5_ = theme_make_color_pattern (self, "#73D216");
	_cairo_pattern_destroy0 (self->priv->tile_colors[5]);
	self->priv->tile_colors[5] = _tmp5_;
	_tmp6_ = theme_make_color_pattern (self, "#3465A4");
	_cairo_pattern_destroy0 (self->priv->tile_colors[6]);
	self->priv->tile_colors[6] = _tmp6_;
	_tmp7_ = theme_make_color_pattern (self, "#75507B");
	_cairo_pattern_destroy0 (self->priv->tile_colors[7]);
	self->priv->tile_colors[7] = _tmp7_;
	_tmp8_ = theme_make_color_pattern (self, "#BABDB6");
	_cairo_pattern_destroy0 (self->priv->tile_colors[8]);
	self->priv->tile_colors[8] = _tmp8_;
	_tmp9_ = theme_make_color_pattern (self, "#FFFFFF");
	_cairo_pattern_destroy0 (self->priv->tile_colors[9]);
	self->priv->tile_colors[9] = _tmp9_;
	_tmp10_ = theme_make_color_pattern (self, "#CCCCCC");
	_cairo_pattern_destroy0 (self->priv->paused_color);
	self->priv->paused_color = _tmp10_;
	_tmp11_ = cairo_pattern_create_rgb ((gdouble) 1, (gdouble) 1, (gdouble) 1);
	_cairo_pattern_destroy0 (self->priv->text_colors[0]);
	self->priv->text_colors[0] = _tmp11_;
	_tmp12_ = cairo_pattern_create_rgb ((gdouble) 1, (gdouble) 1, (gdouble) 1);
	_cairo_pattern_destroy0 (self->priv->text_colors[1]);
	self->priv->text_colors[1] = _tmp12_;
	_tmp13_ = cairo_pattern_create_rgb ((gdouble) 1, (gdouble) 1, (gdouble) 1);
	_cairo_pattern_destroy0 (self->priv->text_colors[2]);
	self->priv->text_colors[2] = _tmp13_;
	_tmp14_ = cairo_pattern_create_rgb ((gdouble) 1, (gdouble) 1, (gdouble) 1);
	_cairo_pattern_destroy0 (self->priv->text_colors[3]);
	self->priv->text_colors[3] = _tmp14_;
	_tmp15_ = cairo_pattern_create_rgb ((gdouble) 0, (gdouble) 0, (gdouble) 0);
	_cairo_pattern_destroy0 (self->priv->text_colors[4]);
	self->priv->text_colors[4] = _tmp15_;
	_tmp16_ = cairo_pattern_create_rgb ((gdouble) 0, (gdouble) 0, (gdouble) 0);
	_cairo_pattern_destroy0 (self->priv->text_colors[5]);
	self->priv->text_colors[5] = _tmp16_;
	_tmp17_ = cairo_pattern_create_rgb ((gdouble) 1, (gdouble) 1, (gdouble) 1);
	_cairo_pattern_destroy0 (self->priv->text_colors[6]);
	self->priv->text_colors[6] = _tmp17_;
	_tmp18_ = cairo_pattern_create_rgb ((gdouble) 1, (gdouble) 1, (gdouble) 1);
	_cairo_pattern_destroy0 (self->priv->text_colors[7]);
	self->priv->text_colors[7] = _tmp18_;
	_tmp19_ = cairo_pattern_create_rgb ((gdouble) 0, (gdouble) 0, (gdouble) 0);
	_cairo_pattern_destroy0 (self->priv->text_colors[8]);
	self->priv->text_colors[8] = _tmp19_;
	_tmp20_ = cairo_pattern_create_rgb ((gdouble) 0, (gdouble) 0, (gdouble) 0);
	_cairo_pattern_destroy0 (self->priv->text_colors[9]);
	self->priv->text_colors[9] = _tmp20_;
	return self;
}

Theme*
theme_new (void)
{
	return theme_construct (TYPE_THEME);
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result = '\0';
	g_return_val_if_fail (self != NULL, '\0');
	_tmp0_ = ((gchar*) self)[index];
	result = _tmp0_;
	return result;
}

static cairo_pattern_t*
theme_make_color_pattern (Theme* self,
                          const gchar* color)
{
	gdouble r = 0.0;
	gdouble g = 0.0;
	gdouble b = 0.0;
	cairo_pattern_t* _tmp0_;
	cairo_pattern_t* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (color != NULL, NULL);
	r = ((theme_hex_value (self, string_get (color, (glong) 1)) * 16) + theme_hex_value (self, string_get (color, (glong) 2))) / 255.0;
	g = ((theme_hex_value (self, string_get (color, (glong) 3)) * 16) + theme_hex_value (self, string_get (color, (glong) 4))) / 255.0;
	b = ((theme_hex_value (self, string_get (color, (glong) 5)) * 16) + theme_hex_value (self, string_get (color, (glong) 6))) / 255.0;
	_tmp0_ = cairo_pattern_create_rgb (r, g, b);
	result = _tmp0_;
	return result;
}

static gdouble
theme_hex_value (Theme* self,
                 gchar c)
{
	gboolean _tmp0_ = FALSE;
	gdouble result = 0.0;
	g_return_val_if_fail (self != NULL, 0.0);
	if (c >= '0') {
		_tmp0_ = c <= '9';
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		result = (gdouble) (c - '0');
		return result;
	} else {
		gboolean _tmp1_ = FALSE;
		if (c >= 'a') {
			_tmp1_ = c <= 'f';
		} else {
			_tmp1_ = FALSE;
		}
		if (_tmp1_) {
			result = (gdouble) ((c - 'a') + 10);
			return result;
		} else {
			gboolean _tmp2_ = FALSE;
			if (c >= 'A') {
				_tmp2_ = c <= 'F';
			} else {
				_tmp2_ = FALSE;
			}
			if (_tmp2_) {
				result = (gdouble) ((c - 'A') + 10);
				return result;
			} else {
				result = (gdouble) 0;
				return result;
			}
		}
	}
}

void
theme_draw_arrow (Theme* self,
                  cairo_t* context,
                  guint size,
                  guint gap)
{
	gdouble w = 0.0;
	gdouble h = 0.0;
	guint depth = 0U;
	gdouble dx = 0.0;
	gdouble dy = 0.0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (context != NULL);
	w = gap * 0.5;
	h = size * 1.5;
	depth = MIN ((guint) (size * 0.025), (guint) 2);
	dx = 1.4142 * depth;
	dy = 6.1623 * depth;
	cairo_move_to (context, (gdouble) 0, (gdouble) 0);
	cairo_line_to (context, w, h * 0.5);
	cairo_line_to (context, w, (-h) * 0.5);
	cairo_close_path (context);
	cairo_set_source_rgba (context, (gdouble) 0, (gdouble) 0, (gdouble) 0, 0.125);
	cairo_fill (context);
	cairo_move_to (context, w, (-h) * 0.5);
	cairo_line_to (context, w, h * 0.5);
	cairo_line_to (context, w - depth, (h * 0.5) - dy);
	cairo_line_to (context, w - depth, ((-h) * 0.5) + dy);
	cairo_close_path (context);
	cairo_set_source_rgba (context, (gdouble) 1, (gdouble) 1, (gdouble) 1, 0.125);
	cairo_fill (context);
	cairo_move_to (context, w, (-h) * 0.5);
	cairo_line_to (context, (gdouble) 0, (gdouble) 0);
	cairo_line_to (context, w, h * 0.5);
	cairo_line_to (context, w - depth, (h * 0.5) - dy);
	cairo_line_to (context, dx, (gdouble) 0);
	cairo_line_to (context, w - depth, ((-h) * 0.5) + dy);
	cairo_close_path (context);
	cairo_set_source_rgba (context, (gdouble) 0, (gdouble) 0, (gdouble) 0, 0.25);
	cairo_fill (context);
}

void
theme_draw_socket (Theme* self,
                   cairo_t* context,
                   guint size)
{
	guint depth = 0U;
	g_return_if_fail (self != NULL);
	g_return_if_fail (context != NULL);
	depth = MIN ((guint) (size * 0.05), (guint) 4);
	cairo_rectangle (context, (gdouble) depth, (gdouble) depth, (gdouble) (size - (depth * 2)), (gdouble) (size - (depth * 2)));
	cairo_set_source_rgba (context, (gdouble) 0, (gdouble) 0, (gdouble) 0, 0.125);
	cairo_fill (context);
	cairo_move_to (context, (gdouble) size, (gdouble) 0);
	cairo_line_to (context, (gdouble) 0, (gdouble) 0);
	cairo_line_to (context, (gdouble) 0, (gdouble) size);
	cairo_line_to (context, (gdouble) depth, (gdouble) (size - depth));
	cairo_line_to (context, (gdouble) depth, (gdouble) depth);
	cairo_line_to (context, (gdouble) (size - depth), (gdouble) depth);
	cairo_close_path (context);
	cairo_set_source_rgba (context, (gdouble) 0, (gdouble) 0, (gdouble) 0, 0.25);
	cairo_fill (context);
	cairo_move_to (context, (gdouble) 0, (gdouble) size);
	cairo_line_to (context, (gdouble) size, (gdouble) size);
	cairo_line_to (context, (gdouble) size, (gdouble) 0);
	cairo_line_to (context, (gdouble) (size - depth), (gdouble) depth);
	cairo_line_to (context, (gdouble) (size - depth), (gdouble) (size - depth));
	cairo_line_to (context, (gdouble) depth, (gdouble) (size - depth));
	cairo_close_path (context);
	cairo_set_source_rgba (context, (gdouble) 1, (gdouble) 1, (gdouble) 1, 0.125);
	cairo_fill (context);
}

void
theme_draw_paused_tile (Theme* self,
                        cairo_t* context,
                        guint size)
{
	cairo_pattern_t* _tmp0_;
	cairo_pattern_t* _tmp1_;
	cairo_pattern_t* _tmp2_;
	cairo_pattern_t* _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (context != NULL);
	_tmp0_ = self->priv->paused_color;
	_tmp1_ = self->priv->paused_color;
	_tmp2_ = self->priv->paused_color;
	_tmp3_ = self->priv->paused_color;
	theme_draw_tile_background (self, context, size, _tmp0_, _tmp1_, _tmp2_, _tmp3_);
}

void
theme_draw_tile (Theme* self,
                 cairo_t* context,
                 guint size,
                 Tile* tile)
{
	cairo_pattern_t* _tmp0_;
	cairo_pattern_t* _tmp1_;
	cairo_pattern_t* _tmp2_;
	cairo_pattern_t* _tmp3_;
	cairo_pattern_t* _tmp4_;
	cairo_pattern_t* _tmp5_;
	cairo_pattern_t* _tmp6_;
	cairo_pattern_t* _tmp7_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (context != NULL);
	_tmp0_ = self->priv->tile_colors[tile->north];
	_tmp1_ = self->priv->tile_colors[tile->east];
	_tmp2_ = self->priv->tile_colors[tile->south];
	_tmp3_ = self->priv->tile_colors[tile->west];
	theme_draw_tile_background (self, context, size, _tmp0_, _tmp1_, _tmp2_, _tmp3_);
	cairo_select_font_face (context, "Sans", CAIRO_FONT_SLANT_NORMAL, CAIRO_FONT_WEIGHT_BOLD);
	cairo_set_font_size (context, size / 3.5);
	_tmp4_ = self->priv->text_colors[tile->north];
	cairo_set_source (context, _tmp4_);
	theme_draw_number (self, context, size * 0.5, (gdouble) (size / 5), (guint) tile->north);
	_tmp5_ = self->priv->text_colors[tile->south];
	cairo_set_source (context, _tmp5_);
	theme_draw_number (self, context, size * 0.5, (gdouble) ((size * 4) / 5), (guint) tile->south);
	_tmp6_ = self->priv->text_colors[tile->east];
	cairo_set_source (context, _tmp6_);
	theme_draw_number (self, context, (gdouble) ((size * 4) / 5), size * 0.5, (guint) tile->east);
	_tmp7_ = self->priv->text_colors[tile->west];
	cairo_set_source (context, _tmp7_);
	theme_draw_number (self, context, (gdouble) (size / 5), size * 0.5, (guint) tile->west);
}

static void
theme_draw_tile_background (Theme* self,
                            cairo_t* context,
                            guint size,
                            cairo_pattern_t* north_color,
                            cairo_pattern_t* east_color,
                            cairo_pattern_t* south_color,
                            cairo_pattern_t* west_color)
{
	guint depth = 0U;
	gdouble dx = 0.0;
	gdouble dy = 0.0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (context != NULL);
	g_return_if_fail (north_color != NULL);
	g_return_if_fail (east_color != NULL);
	g_return_if_fail (south_color != NULL);
	g_return_if_fail (west_color != NULL);
	depth = MIN ((guint) (size * 0.05), (guint) 4);
	dx = 2.4142 * depth;
	dy = 1.4142 * depth;
	cairo_rectangle (context, (gdouble) 0, (gdouble) 0, (gdouble) size, size * 0.5);
	cairo_set_source (context, north_color);
	cairo_fill (context);
	cairo_move_to (context, (gdouble) 0, (gdouble) 0);
	cairo_line_to (context, (gdouble) size, (gdouble) 0);
	cairo_line_to (context, size - dx, (gdouble) depth);
	cairo_line_to (context, dx, (gdouble) depth);
	cairo_line_to (context, size * 0.5, (size * 0.5) - dy);
	cairo_line_to (context, size * 0.5, size * 0.5);
	cairo_close_path (context);
	cairo_set_source_rgba (context, (gdouble) 1, (gdouble) 1, (gdouble) 1, 0.125);
	cairo_fill (context);
	cairo_move_to (context, (gdouble) size, (gdouble) 0);
	cairo_line_to (context, size * 0.5, size * 0.5);
	cairo_line_to (context, size * 0.5, (size * 0.5) - dy);
	cairo_line_to (context, size - dx, (gdouble) depth);
	cairo_close_path (context);
	cairo_set_source_rgba (context, (gdouble) 0, (gdouble) 0, (gdouble) 0, 0.25);
	cairo_fill (context);
	cairo_rectangle (context, (gdouble) 0, size * 0.5, (gdouble) size, size * 0.5);
	cairo_set_source (context, south_color);
	cairo_fill (context);
	cairo_move_to (context, (gdouble) 0, (gdouble) size);
	cairo_line_to (context, dx, (gdouble) (size - depth));
	cairo_line_to (context, size * 0.5, (size * 0.5) + dy);
	cairo_line_to (context, size * 0.5, size * 0.5);
	cairo_close_path (context);
	cairo_set_source_rgba (context, (gdouble) 1, (gdouble) 1, (gdouble) 1, 0.125);
	cairo_fill (context);
	cairo_move_to (context, (gdouble) 0, (gdouble) size);
	cairo_line_to (context, (gdouble) size, (gdouble) size);
	cairo_line_to (context, size * 0.5, size * 0.5);
	cairo_line_to (context, size * 0.5, (size * 0.5) + dy);
	cairo_line_to (context, size - dx, (gdouble) (size - depth));
	cairo_line_to (context, dx, (gdouble) (size - depth));
	cairo_close_path (context);
	cairo_set_source_rgba (context, (gdouble) 0, (gdouble) 0, (gdouble) 0, 0.25);
	cairo_fill (context);
	cairo_move_to (context, (gdouble) size, (gdouble) 0);
	cairo_line_to (context, (gdouble) size, (gdouble) size);
	cairo_line_to (context, size * 0.5, size * 0.5);
	cairo_close_path (context);
	cairo_set_source (context, east_color);
	cairo_fill (context);
	cairo_move_to (context, (gdouble) size, (gdouble) 0);
	cairo_line_to (context, size * 0.5, size * 0.5);
	cairo_line_to (context, (gdouble) size, (gdouble) size);
	cairo_line_to (context, (gdouble) (size - depth), size - dx);
	cairo_line_to (context, (size * 0.5) + dy, size * 0.5);
	cairo_line_to (context, (gdouble) (size - depth), dx);
	cairo_close_path (context);
	cairo_set_source_rgba (context, (gdouble) 1, (gdouble) 1, (gdouble) 1, 0.125);
	cairo_fill (context);
	cairo_move_to (context, (gdouble) size, (gdouble) 0);
	cairo_line_to (context, (gdouble) size, (gdouble) size);
	cairo_line_to (context, (gdouble) (size - depth), size - dx);
	cairo_line_to (context, (gdouble) (size - depth), dx);
	cairo_close_path (context);
	cairo_set_source_rgba (context, (gdouble) 0, (gdouble) 0, (gdouble) 0, 0.25);
	cairo_fill (context);
	cairo_move_to (context, (gdouble) 0, (gdouble) 0);
	cairo_line_to (context, (gdouble) 0, (gdouble) size);
	cairo_line_to (context, size * 0.5, size * 0.5);
	cairo_close_path (context);
	cairo_set_source (context, west_color);
	cairo_fill (context);
	cairo_move_to (context, (gdouble) 0, (gdouble) 0);
	cairo_line_to (context, (gdouble) 0, (gdouble) size);
	cairo_line_to (context, (gdouble) depth, size - dx);
	cairo_line_to (context, (gdouble) depth, dx);
	cairo_close_path (context);
	cairo_set_source_rgba (context, (gdouble) 1, (gdouble) 1, (gdouble) 1, 0.125);
	cairo_fill (context);
	cairo_move_to (context, (gdouble) 0, (gdouble) 0);
	cairo_line_to (context, size * 0.5, size * 0.5);
	cairo_line_to (context, (gdouble) 0, (gdouble) size);
	cairo_line_to (context, (gdouble) depth, size - dx);
	cairo_line_to (context, (size * 0.5) - dy, size * 0.5);
	cairo_line_to (context, (gdouble) depth, dx);
	cairo_close_path (context);
	cairo_set_source_rgba (context, (gdouble) 0, (gdouble) 0, (gdouble) 0, 0.25);
	cairo_fill (context);
	cairo_set_line_width (context, 1.0);
	cairo_set_source_rgb (context, 0.0, 0.0, 0.0);
	cairo_rectangle (context, 0.5, 0.5, size - 1.0, size - 1.0);
	cairo_stroke (context);
}

static void
theme_draw_number (Theme* self,
                   cairo_t* context,
                   gdouble x,
                   gdouble y,
                   guint number)
{
	gchar* text = NULL;
	gchar* _tmp0_;
	cairo_text_extents_t extents = {0};
	cairo_text_extents_t _tmp1_ = {0};
	cairo_text_extents_t _tmp2_;
	cairo_text_extents_t _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (context != NULL);
	_tmp0_ = g_strdup_printf ("%u", number);
	text = _tmp0_;
	cairo_text_extents (context, text, &_tmp1_);
	extents = _tmp1_;
	_tmp2_ = extents;
	_tmp3_ = extents;
	cairo_move_to (context, x - (_tmp2_.width / 2.0), y + (_tmp3_.height / 2.0));
	cairo_show_text (context, text);
	_g_free0 (text);
}

static void
theme_class_init (ThemeClass * klass,
                  gpointer klass_data)
{
	theme_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &Theme_private_offset);
	G_OBJECT_CLASS (klass)->finalize = theme_finalize;
}

static void
theme_instance_init (Theme * self,
                     gpointer klass)
{
	self->priv = theme_get_instance_private (self);
}

static void
theme_finalize (GObject * obj)
{
	Theme * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_THEME, Theme);
	_vala_array_destroy (self->priv->tile_colors, 10, (GDestroyNotify) cairo_pattern_destroy);
	_cairo_pattern_destroy0 (self->priv->paused_color);
	_vala_array_destroy (self->priv->text_colors, 10, (GDestroyNotify) cairo_pattern_destroy);
	G_OBJECT_CLASS (theme_parent_class)->finalize (obj);
}

GType
theme_get_type (void)
{
	static volatile gsize theme_type_id__volatile = 0;
	if (g_once_init_enter (&theme_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ThemeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) theme_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Theme), 0, (GInstanceInitFunc) theme_instance_init, NULL };
		GType theme_type_id;
		theme_type_id = g_type_register_static (G_TYPE_OBJECT, "Theme", &g_define_type_info, 0);
		Theme_private_offset = g_type_add_instance_private (theme_type_id, sizeof (ThemePrivate));
		g_once_init_leave (&theme_type_id__volatile, theme_type_id);
	}
	return theme_type_id__volatile;
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

